// Type: Ninject.Modules.NinjectModule
// Assembly: Ninject, Version=2.0.0.0, Culture=neutral, PublicKeyToken=c7192dc5380945e7
// Assembly location: D:\Prabir\Documents\Visual Studio 2010\Projects\Prabir.NinjectSample\libs\Ninject-2.0.0.0-release-net-3.5\Ninject.dll

using Ninject;
using Ninject.Infrastructure;
using Ninject.Planning.Bindings;
using Ninject.Syntax;
using System;
using System.Collections.Generic;

namespace Ninject.Modules
{
    public abstract class NinjectModule : BindingRoot, INinjectModule, IHaveKernel
    {
        public ICollection<IBinding> Bindings { get; }

        #region INinjectModule Members

        public void OnLoad(IKernel kernel);
        public void OnUnload(IKernel kernel);
        public IKernel Kernel { get; protected set; }
        public virtual string Name { get; }

        #endregion

        public abstract void Load();
        public virtual void Unload();
        public override void Unbind(Type service);
        public override void AddBinding(IBinding binding);
        public override void RemoveBinding(IBinding binding);
        protected override BindingBuilder<T> CreateBindingBuilder<T>(IBinding binding);
    }
}
